pub use radn_derive::SharedFunctorAny;

use super::*;

pub trait SharedFunctorAny: WeakFunctorAny {
    type SharedAny<'a, A: 'a + Clone>: 'a + Clone
    where
        Self: 'a;

    fn share<'a, A: 'a + Clone>(fa: Self::FAny<'a, A>) -> Self::SharedAny<'a, A>
    where
        Self: 'a;

    fn unshare<'a, A: 'a + Clone>(sa: Self::SharedAny<'a, A>) -> Self::FAny<'a, A>
    where
        Self: 'a;
}

pub trait SharedFunctor<'a>: WeakFunctor<'a> {
    type Shared<A: 'a + Clone>: 'a + Clone;

    fn share<A: 'a + Clone>(fa: Self::F<A>) -> Self::Shared<A>;

    fn unshare<A: 'a + Clone>(sa: Self::Shared<A>) -> Self::F<A>;
}

impl<'a, T: 'a + SharedFunctorAny> SharedFunctor<'a> for T {
    type Shared<A: 'a + Clone> = T::SharedAny<'a, A>;

    fn share<A: 'a + Clone>(fa: Self::F<A>) -> Self::Shared<A> {
        T::share(fa)
    }

    fn unshare<A: 'a + Clone>(sa: Self::Shared<A>) -> Self::F<A> {
        T::unshare(sa)
    }
}
